﻿// v2.1 - cleanup and add ability for computer to play either X or O.
// v2.0 - switched to Minimax algorithm, as mine doesn't work!

function GetPluginSettings()
{
	return {
		"name":			"BHT Tic-Tac-Toe AI",	// as appears in 'insert object' dialog, can be changed as long as "id" stays the same
		"id":			"BHT_TicTacToe_AI",		// this is used to identify this plugin and is saved to the project; never change it
		"version":		"2.1",					// (float in x.y format) Plugin version - C2 shows compatibility warnings based on this
		"description":	"Tic-Tac-Toe AI",
		"author":		"David Taylor/Black Hornet Technologies",
		"help url":		"http://www.blackhornettechnologies.com",
		"category":		"Game logic",				// Prefer to re-use existing categories, but you can set anything here
		"type":			"object",				// either "world" (appears in layout and is drawn), else "object"
		"rotatable":	false,					// only used when "type" is "world".  Enables an angle property on the object.
		"flags":		0						// uncomment lines to enable flags...
					//	| pf_singleglobal		// exists project-wide, e.g. mouse, keyboard.  "type" must be "object".
					//	| pf_texture			// object has a single texture (e.g. tiled background)
					//	| pf_position_aces		// compare/set/get x, y...
					//	| pf_size_aces			// compare/set/get width, height...
					//	| pf_angle_aces			// compare/set/get angle (recommended that "rotatable" be set to true)
					//	| pf_appearance_aces	// compare/set/get visible, opacity...
					//	| pf_tiling				// adjusts image editor features to better suit tiled images (e.g. tiled background)
					//	| pf_animations			// enables the animations system.  See 'Sprite' for usage
					//	| pf_zorder_aces		// move to top, bottom, layer...
	};
};

AddNumberParam("index", "Index in the matrix of this move.", "0");
AddAction(0, af_none, "Move Player X", "Store a move", "Store move at [{0}] for player X", "Store a move in the matrix for X.", "SetMoveX");

AddNumberParam("index", "Index in the matrix of this move.", "0");
AddAction(1, af_none, "Move Player O", "Store a move", "Store move at [{0}] for player O", "Store a move in the matrix for O.", "SetMoveO");

AddAction(2, af_none, "Check for Winner", "Check if we have a winner", "Check if we have a winner", "Check if we have a winner. Store the winner ID and the corresponding index in the Winners array.", "CheckForWinner");

AddExpression(0, ef_return_number, "Get next O move", "Move", "GetMoveO", "Get the next move for player O.");
AddExpression(1, ef_return_number, "Get next X move", "Move", "GetMoveX", "Get the next move for player X.");
AddExpression(2, ef_return_number, "Get winner ID", "Win Data", "GetWinner", "Get the winner, if any. 0 is no winner, 1 is X, 2 is O. -1 is game isn't over yet.");
AddExpression(3, ef_return_number, "Get winner index", "Win Data", "GetWinnerIndex", "Get the index of the Winner array.");

////////////////////////////////////////
ACESDone();

////////////////////////////////////////

var property_list = [
	];
	
// Called by IDE when a new object type is to be created
function CreateIDEObjectType()
{
	return new IDEObjectType();
}

// Class representing an object type in the IDE
function IDEObjectType()
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
}

// Called by IDE when a new object instance of this type is to be created
IDEObjectType.prototype.CreateInstance = function(instance)
{
	return new IDEInstance(instance);
}

// Class representing an individual instance of an object in the IDE
function IDEInstance(instance, type)
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
	
	// Save the constructor parameters
	this.instance = instance;
	this.type = type;
	
	// Set the default property values from the property table
	this.properties = {};
	
	for (var i = 0; i < property_list.length; i++)
		this.properties[property_list[i].name] = property_list[i].initial_value;
}

// Called when inserted via Insert Object Dialog for the first time
IDEInstance.prototype.OnInserted = function()
{
}

// Called when double clicked in layout
IDEInstance.prototype.OnDoubleClicked = function()
{
}

// Called after a property has been changed in the properties bar
IDEInstance.prototype.OnPropertyChanged = function(property_name)
{
}

// For rendered objects to load fonts or textures
IDEInstance.prototype.OnRendererInit = function(renderer)
{
}

// Called to draw self in the editor if a layout object
IDEInstance.prototype.Draw = function(renderer)
{
}

// For rendered objects to release fonts or textures
IDEInstance.prototype.OnRendererReleased = function(renderer)
{
}